#include <iostream>

using namespace std;

int main()
{
    long int n,k,t=0,g=1;
    cin>>n>>k;
    int a[n],b[k-1];
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
    }
    for(int i=0;i<k-1;i++)
    {
        if(a[i]>a[n-g])
        {
            b[t]=a[i]-a[n-g];
            t=t+1;
        }
        else{
            b[t]=a[n-g]-a[i];
            t=t+1;
        }
        g=g+1;
    }
    int h=b[0];
    for(int i=0;i<k-1;i++)
    {
        if(h>b[i])
        {
            h=h;
        }
        else{
            h=b[i];
        }
    }
    cout<<h;
    return 0;
}